LIST P=16F628A 
#INCLUDE  <P16F628A.INC>
__CONFIG b'11111101010000'

M_D equ 20h ;  
M_E equ 21h ;  
H_D equ 22h ;  
H_E equ 23h ;  

M_TEMP equ 24h ;  
H_TEMP equ 25h ;  

TEMP equ 26h
COUNT equ 27h

R01 equ 40h
R02 equ 41h


;=========== 
BSF	STATUS,RP0 
MOVLW 	b'11111111' 
MOVWF	TRISA
MOVLW	b'00000000'
MOVWF	TRISB
BCF	STATUS,RP0
MOVLW	0x07 
MOVWF	CMCON





;===========  =======================
MOVLW b'01100011' ; 
MOVWF M_TEMP
MOVLW b'00010010'
MOVWF H_TEMP
 
START

;=====     ======
ENCOD	MOVF M_TEMP,w ;     
		ANDLW b'00001111' ;     
		MOVWF M_E ;     -

		SWAPF M_TEMP,0 ;         
		ANDLW b'00001111' ;     
		MOVWF M_D ;     -

		MOVF H_TEMP,W ;     
		ANDLW b'00001111' ;     
		MOVWF H_E ;     -

		SWAPF H_TEMP,0 ;         
		ANDLW b'00000011' ;     
		MOVWF H_D ;     -
	

;=======     ===========
IND	MOVF M_E,W
	CALL TABL
 	CALL OUT_REG ;   
   
	MOVF M_D,W 
	CALL TABL
	CALL OUT_REG ;   
	clrwdt

	MOVF H_E,W
	CALL TABL
	CALL OUT_REG ;   

	MOVF H_D,W
	CALL TABL
	CALL OUT_REG ;   

	MOVLW .0
	CALL END_REG
	clrwdt

	BSF PORTB,RB2  ;
	NOP                         
	BCF PORTB,RB2  ;   LE

;===========  =========
BTFSC PORTA,RA1 ; 
goto        $+3 ;     ,    3  
CALL KAY_50 ;    
BTFSC PORTA,RA1 ;  
goto        METKA1 ; ,  
CALL KAY_50
CALL KAY_50
CALL KAY_50
CALL KAY_50
BCF STATUS,Z ;   Z
MOVF M_TEMP,W ;    
ANDLW b'00001111' ;  
SUBLW b'00001001' ;   9 
BTFSS STATUS,Z ;  
goto $+2 ;  0
goto $+3 ;  1
INCF M_TEMP ;  1
goto $+3 ;
MOVLW b'00000111' ; 
ADDWF M_TEMP,F ;  10
METKA1
NOP

BTFSC PORTA,RA0 ; 
goto        $+3
CALL KAY_50
BTFSC PORTA,RA0
goto  METKA2
CALL KAY_50
CALL KAY_50
CALL KAY_50
CALL KAY_50
BCF STATUS,Z ; 
MOVF H_TEMP,W
ANDLW b'00001111' ; 
SUBLW b'00001001' ;
BTFSS STATUS,Z
goto $+2
goto $+3
INCF H_TEMP ;
goto $+3
MOVLW b'00000111' ; 
ADDWF H_TEMP,F
METKA2
NOP

GOTO START

;--------------------------------------------
	OUT_REG	MOVWF TEMP
          			MOVLW .7
				MOVWF COUNT

	OUT_LOOP	RLF TEMP     ;  
 				BTFSS STATUS,C 
				
				BCF PORTB,RB0  ;
				BTFSC STATUS,C       
				BSF      PORTB,RB0  ;   SDI
				NOP
				NOP

				BSF PORTB,RB1  ;  
          			NOP        
				NOP                
				BCF PORTB,RB1  ;  CLK
				NOP

				DECFSZ COUNT ;   
				GOTO OUT_LOOP ;   
				NOP

                  			 RETURN

	END_REG	MOVWF TEMP
          			MOVLW .4
				MOVWF COUNT

	OUT_LOOP1	RLF TEMP ;  
 				BTFSS STATUS,C 
				
				BCF PORTB,RB0  ;
				BTFSC STATUS,C         
				BSF      PORTB,RB0  ;   SDI
				NOP
				NOP

				BSF PORTB,RB1  ;  
          			NOP   
				NOP                    
				BCF PORTB,RB1  ;  CLK
				NOP

				DECFSZ COUNT ;   
				GOTO OUT_LOOP1 ;   
				NOP
                  			 RETURN

; =============   ======================
TABL	ADDWF PCL,F
			retlw	b'11111100' ; 0
			retlw	b'01100000' ; 1
			retlw	b'11011010' ; 2
			retlw 	b'11110010' ; 3
			retlw 	b'01100110' ; 4
			retlw 	b'10110110' ; 5
			retlw 	b'10111110' ; 6
			retlw 	b'11100000' ; 7
			retlw 	b'11111110' ; 8
			retlw 	b'11110110' ; 9

KAY_50  	 movlw       .248
            movwf       R01
            movlw       .26
            movwf       R02
            decfsz      R01,F
            goto        $-1
            decfsz      R02,F
            goto        $-3
            nop

			RETURN

END
