LIST P=16F628A 
#INCLUDE  <P16F628A.INC>
__CONFIG b'11111101010000'

COUNTER equ 21h
I2CTEMP equ 22h
FLAG equ 23h
S_TEMP equ 26h
M_TEMP equ 24h
H_TEMP equ 25h

; ========     ==============
BSF STATUS,RB5 ; 
CLRF TRISB ; 
BCF STATUS,RB5 
;==============      =============
BSF PORTB,RB5
BSF PORTB,RB6
  
START 

call STARTI2C
MOVLW b'10100100' 
call I2CSEND

GOTO START

	;==============

STARTI2C	BCF PORTB,RB5 ; SDA=0
			CALL PAUSE5
			BCF PORTB,RB6 ; SCL=0
			CALL PAUSE5
			RETURN

	;===================

R_start	bcf PORTB,RB6 ; SCL=0
		CALL PAUSE5
		bsf PORTB,RB5 ; SDA=1
		CALL PAUSE5
		bsf PORTB,RB6 ; SCL=1
		CALL PAUSE5
		bcf PORTB,RB5 ; SDA=0
		CALL PAUSE5
		bcf PORTB,RB6 
			RETURN


	;========== ==============

I2CSEND	MOVWF I2CTEMP
		MOVLW .8
		MOVWF COUNTER
		
	LOOP	BCF STATUS,C ;   
			BCF PORTB,RB6 ;
	NOP
	NOP
			RLF I2CTEMP,F ;
			
			BTFSS STATUS,C ;
			BCF PORTB,RB5 ;
			BTFSC STATUS,C ;
			BSF PORTB,RB5 ;

			DECFSZ COUNTER,F ;
			goto $+2
			goto $+3

			BSF PORTB,RB6 ;
			goto LOOP

			BSF PORTB,RB6 ;
			BTFSS PORTB,RB6 ;
			BCF PORTB,RB6
			nop
			BSF STATUS,RP0 ;
			BSF TRISB,RB5 ;
			BCF STATUS,RP0 ;
			BCF PORTB,RB6 ;
			
			;======ASK
			NOP
			NOP
			NOP

			BTFSS PORTB,RB5
			BCF FLAG,h'10'
			BTFSC PORTB,RB5
			BSF FLAG,h'10'
			
			NOP
			NOP
			NOP
			NOP
				RETURN

;==========   ==============
I2CREAD	BSF STATUS,RP0 ;
		BSF TRISB,RB5 ;
		BCF STATUS,RP0 ;
		MOVLW .8
		MOVWF COUNTER ;

	LOOP1	BSF PORTB,RB6 ; SCL=1
			CALL PAUSE5
			BCF STATUS,Z ; 
			BTFSC PORTB,RB5 ; SDA=0, 
			BSF STATUS,Z ;
			BCF PORTB,RB6 ; SCL=0
			CALL PAUSE5
			RLF I2CTEMP,F ;
			DECFSZ COUNTER ; 
			GOTO LOOP1
		
		BSF STATUS,RP0
		BCF TRISB,RB5
		BCF STATUS,RP0
		BSF PORTB,RB5 ; SDA=1
		BTFSS FLAG,1 ; 	     ACK
		GOTO $+2
		BCF PORTB,RB5 ; SDA=0
		BSF PORTB,RB6 ; SCL=1
		CALL PAUSE5
		BCF PORTB,RB6 ;SCL=0
		BCF PORTB,RB5 ;SDA=0
		MOVF I2CTEMP,W
			RETURN

	;============  =========

I2CSTOP	CALL PAUSE5
			BSF PORTB,RB6 ; SCL=1
			CALL PAUSE5 
			BSF PORTB,RB5 ; SDA=1
			RETURN




		PAUSE5	NOP
					NOP 
					NOP
				
			RETURN

		END