LIST P=16F628A 
#INCLUDE  <P16F628A.INC>
__CONFIG b'11111101010000'

COUNT equ 21h
RX_DAT equ 22h
TX_DAT equ 23h
ASK equ 27h
Reg_1 equ 26h
Reg_2 equ 24h
Reg_3 equ 25h



#define SCL PORTB,RB6
#define SDA PORTB,RB5

#define A_RX ASK,1
#define A_TX ASK,7

banksel TRISB 
bcf TRISB,6 ;SCL  
bcf TRISB,5
banksel 0  


start

call I_START
movlw b'11010000'
call TX_IIS


movlw b'00000000' ; adr
call TX_IIS


movlw b'00000011' ; c
call TX_IIS

movlw b'00000011' ; m
call TX_IIS

movlw b'00000100' ;h
call TX_IIS

movlw b'00000001' ; w
call TX_IIS

movlw b'00000010' ; d
call TX_IIS


movlw b'00010001' ;m
call TX_IIS

movlw b'00100111' ; e
call TX_IIS

 movlw b'10010000' ; reg
call TX_IIS

call I_STOP

 movlw       .16
            movwf       Reg_1
            movlw       .85
            movwf       Reg_2
            movlw       .102
            movwf       Reg_3
            decfsz      Reg_1,F
            goto        $-1
            clrwdt
            decfsz      Reg_2,F
            goto        $-4
            decfsz      Reg_3,F
goto start

I_START
bsf SCL ; SCL=1
nop
nop

bsf 	SDA ; SDA=1

nop
nop
nop

bcf SDA ; SDA=0

nop
nop
nop
nop ;
bcf SCL ; SCL=0
nop ;
return


;
I_STOP
nop ;
nop ;
nop ;
nop
bsf SCL ; SCL=1
nop ;
nop ;
nop ;
nop

bsf SDA ; SDA=1

return
;



; ===========   =================
RX_IIS
banksel TRISB
bsf TRISB,5 ;SDA
banksel 0
movlw 0x8 ;
movwf COUNT ;
clrc ;
L_R_II
nop ;
bsf SCL ;
nop ;
nop
nop
nop
btfss SDA ;
clrc ;
btfsc SDA ;
setc ;
rlf RX_DAT,f ;
bcf SCL ;
nop ;
nop ;
decfsz COUNT,f ;
goto L_R_II ;
banksel TRISB
bcf TRISB,5 ;SDA
banksel 0

; ACK 
nop
rrf ASK,0
btfss STATUS,C
bcf SDA 		; 	sda=0
btfsc STATUS,C
bsf SDA			;	sda=1

nop 
nop 
nop 
nop 
bsf SCL ; scl=1
nop 
nop 
nop
nop 
bcf SCL ;scl=0
NOP
bcf SDA  ; sda=0
nop
return
;


;=================  =============
TX_IIS
movwf TX_DAT ; 



movlw 0x8 ;
movwf COUNT ;
clrc ;

L_T_II
rlf TX_DAT,f


btfss STATUS,C
bcf SDA 		; 	sda=0
btfsc STATUS,C
bsf SDA		;	sda=1


bsf SCL ;
nop ;
nop ;
nop ;
nop ;
bcf SCL ;
nop
decfsz COUNT,f ;
goto L_T_II ;
nop

; ACK

bcf SCL
banksel TRISB 
bsf TRISB,5 ;SDA
banksel 0 
clrc 
bsf SCL
nop 
nop 
nop 
nop 
btfss SDA ;
clrc 
btfsc SDA ;
setc 
nop
bcf SCL
nop

return 


END