LIST P=16F628A 
#INCLUDE  <P16F628A.INC>
__CONFIG b'11111101010000'

COUNT equ 21h
RX_DAT equ 22h
TX_DAT equ 23h
Reg_1 equ 26h
Reg_2 equ 24h
Reg_3 equ 25h


#define SCL PORTB,RB6
#define SDA PORTB,RB5
;
banksel TRISB 
bcf TRISB,6 ;SCL  
banksel 0  
bcf SDA
start

call I_START
movlw b'11010000'
call TX_IIS
call RX_ACK


movlw b'00000000' ; adr
call TX_IIS
call RX_ACK

movlw b'00000011' ; c
call TX_IIS
call RX_ACK

movlw b'00000011' ; m
call TX_IIS
call RX_ACK

movlw b'00000000' ;h
call TX_IIS
call RX_ACK

movlw b'00000001' ; w
call TX_IIS
call RX_ACK

movlw b'00000010' ; d
call TX_IIS
call RX_ACK

movlw b'00010001' ;m
call TX_IIS
call RX_ACK

movlw b'00100111' ; e
call TX_IIS
call RX_ACK

 movlw b'10010000' ; reg
call TX_IIS
call RX_ACK

call I_STOP

 movlw       .16
            movwf       Reg_1
            movlw       .85
            movwf       Reg_2
            movlw       .102
            movwf       Reg_3
            decfsz      Reg_1,F
            goto        $-1
            clrwdt
            decfsz      Reg_2,F
            goto        $-4
            decfsz      Reg_3,F
goto start

I_START
bsf SCL ; SCL=1
banksel TRISB 
bsf TRISB,5 ; SDA=1
banksel 0 
nop
nop
nop
banksel TRISB 
bcf TRISB,5 ; SDA=0
banksel 0 
nop
nop
nop
nop ;
bcf SCL ; SCL=0
nop ;
return


;
I_STOP
bcf SCL ;SCL=0
banksel TRISB
bcf TRISB,5 ;SDA=0
banksel 0
nop ;
nop ;
nop ;
nop
bsf SCL ; SCL=1
nop ;
nop ;
nop ;
nop
banksel TRISB
bsf TRISB,5 ; SDA=1
banksel 0
return
;




RX_IIS
banksel TRISB
bsf TRISB,5 ;SDA
banksel 0
movlw 0x8 ;
movwf COUNT ;
clrc ;
L_R_II
nop ;
bsf SCL ;
nop ;
nop
nop
nop
btfss SDA ;
clrc ;
btfsc SDA ;
setc ;
rlf RX_DAT,f ;
bcf SCL ;
nop ;
nop ;
decfsz COUNT,f ;
goto L_R_II ;
return
;



TX_IIS
movwf TX_DAT ; 

banksel TRISB
bcf TRISB,5 ;SDA
banksel 0

movlw 0x8 ;
movwf COUNT ;
clrc ;

L_T_II
bcf SCL
btfsc TX_DAT,7 ;
goto Metka_1 ; 
btfss TX_DAT,7 ;
goto Metka_2 ;

Metka_1		
banksel TRISB
bsf TRISB,5 ;SDA=1
banksel 0
goto Metka_3

Metka_2		
banksel TRISB
bcf TRISB,5 ;SDA=0
banksel 0
Metka_3
nop 
nop
nop
nop 
bsf SCL ;
nop ;
nop ;
nop ;
nop ;
bcf SCL ;
rlf TX_DAT,f ;
decfsz COUNT,f ;
goto L_T_II ;
nop
return 


; ACK
RX_ACK
bcf SCL
banksel TRISB 
bsf TRISB,5 ;SDA
banksel 0 
clrc 
bsf SCL
nop 
nop 
nop 
nop 
btfss SDA ;
clrc 
btfsc SDA ;
setc 
nop
bcf SCL
nop
return 


; ACK 
TX_ACK
nop
skpc 
goto Metka_4
skpnc 
goto Metka_5
Metka_4		
banksel TRISB
bcf TRISB,5 ;SDA=0
banksel 0
goto Metka_6

Metka_5	
banksel TRISB
bsf TRISB,5 ;SDA=1
banksel 0
Metka_6
nop 
nop 
nop 
nop 
bsf SCL
nop 
nop 
nop
nop 
bcf SCL
nop
return




END