LIST P=16F628A 
#INCLUDE  <P16F628A.INC>
__CONFIG b'11111101010000'

I_Cnt equ 21h
I_RX_DAT equ 22h
I_TX_DAT equ 23h
Reg_1 equ 26h
Reg_2 equ 24h
Reg_3 equ 25h


#define SCL PORTB,RB6
#define SDA PORTB,RB5
;

start

call I_START
movlw b'11010000'
call TX_IIS
call RX_ACK


movlw b'00000000' ; adr
call TX_IIS
call RX_ACK

movlw b'00000000' ; c
call TX_IIS
call RX_ACK

movlw 46h ; m
call TX_IIS
call RX_ACK

movlw 15h ;h
call TX_IIS
call RX_ACK

movlw b'00000001' ; w
call TX_IIS
call RX_ACK

movlw b'00000010' ; d
call TX_IIS
call RX_ACK

movlw b'00010001' ;m
call TX_IIS
call RX_ACK

movlw b'00100111' ; e
call TX_IIS
call RX_ACK

 movlw b'10010000' ; reg
call TX_IIS
call RX_ACK

call I_STOP

 movlw       .16
            movwf       Reg_1
            movlw       .85
            movwf       Reg_2
            movlw       .102
            movwf       Reg_3
            decfsz      Reg_1,F
            goto        $-1
            clrwdt
            decfsz      Reg_2,F
            goto        $-4
            decfsz      Reg_3,F
goto start

I_START
bsf SDA ;
banksel TRISB 
bcf TRISB,6 ;SCL
bcf TRISB,5 ;SDA
banksel 0 
bsf SDA ; SDA high
bsf SCL ;SCL is high
nop
nop
nop
nop
bcf SDA ;p 
nop ;
nop ;
nop ;
nop ;
bcf SCL ;
nop ;
return


;
I_STOP
bcf SCL
banksel TRISB
bcf TRISB,6 ;SCL
bcf TRISB,5 ;SDA
banksel 0
bcf SCL
bcf SDA
nop ;
nop ;
nop ;
nop
bsf SCL
nop ;
nop ;
nop ;
nop
bsf SDA
banksel TRISB
bsf TRISB,6 ;SCL
bsf TRISB,5 ;SDA
banksel 0
return
;




RX_IIS
banksel TRISB
bcf TRISB,6 ;SCL
bsf TRISB,5 ;SDA
banksel 0
movlw 0x8 ;
movwf I_Cnt ;
clrc ;
L_R_II
nop ;
bsf SCL ;
nop ;
nop
nop
nop
btfss SDA ;
clrc ;
btfsc SDA ;
setc ;
rlf I_RX_DAT,f ;
bcf SCL ;
nop ;
nop ;
decfsz I_Cnt,f ;
goto L_R_II ;
return
;



TX_IIS
movwf I_TX_DAT ; 
banksel TRISB
bcf TRISB,6 ;SCL
bcf TRISB,5 ;SDA
banksel 0
movlw 0x8 ;
movwf I_Cnt ;
clrc ;
L_T_II
bcf SCL
btfss I_TX_DAT,7 ;
bcf SDA ;
btfsc I_TX_DAT,7 ;
bsf SDA ;
nop 
nop
nop
nop 
bsf SCL ;
nop ;
nop ;
nop ;
nop ;
bcf SCL ;
rlf I_TX_DAT,f ;
decfsz I_Cnt,f ;
goto L_T_II ;
return 


; ACK  ACK   
RX_ACK
bcf SCL
banksel TRISB 
bcf TRISB,6 ;SCL
bsf TRISB,5 ;SDA
banksel 0 
clrc 
bsf SCL
nop 
nop 
nop 
nop 
btfss SDA ;
clrc 
btfsc SDA ;
setc 
bcf SCL
return 


; ACK   
TX_ACK
banksel TRISB 
bcf TRISB,6 ;SCL 
bcf TRISB,5 ;SDA 
banksel 0 
skpc 
bcf SDA
skpnc 
bsf SDA
nop 
nop 
nop 
nop 
bsf SCL
nop 
nop 
nop
nop 
bcf SCL
bcf SDA
return




END